/* gpaste-settings.c generated by valac 0.12.1, the Vala compiler
 * generated from gpaste-settings.vala, do not modify */

/*
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *      Copyright 2011 Marc-Antoine Perennou <Marc-Antoine@Perennou.com>
 *
 *      This file is part of GPaste.
 *
 *      GPaste is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      GPaste is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with GPaste.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <stdio.h>


#define GPASTE_SETTINGS_TYPE_WINDOW (gpaste_settings_window_get_type ())
#define GPASTE_SETTINGS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_SETTINGS_TYPE_WINDOW, GPasteSettingsWindow))
#define GPASTE_SETTINGS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_SETTINGS_TYPE_WINDOW, GPasteSettingsWindowClass))
#define GPASTE_SETTINGS_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_SETTINGS_TYPE_WINDOW))
#define GPASTE_SETTINGS_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_SETTINGS_TYPE_WINDOW))
#define GPASTE_SETTINGS_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_SETTINGS_TYPE_WINDOW, GPasteSettingsWindowClass))

typedef struct _GPasteSettingsWindow GPasteSettingsWindow;
typedef struct _GPasteSettingsWindowClass GPasteSettingsWindowClass;
typedef struct _GPasteSettingsWindowPrivate GPasteSettingsWindowPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GPASTE_SETTINGS_TYPE_MAIN (gpaste_settings_main_get_type ())
#define GPASTE_SETTINGS_MAIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_SETTINGS_TYPE_MAIN, GPasteSettingsMain))
#define GPASTE_SETTINGS_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_SETTINGS_TYPE_MAIN, GPasteSettingsMainClass))
#define GPASTE_SETTINGS_IS_MAIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_SETTINGS_TYPE_MAIN))
#define GPASTE_SETTINGS_IS_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_SETTINGS_TYPE_MAIN))
#define GPASTE_SETTINGS_MAIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_SETTINGS_TYPE_MAIN, GPasteSettingsMainClass))

typedef struct _GPasteSettingsMain GPasteSettingsMain;
typedef struct _GPasteSettingsMainClass GPasteSettingsMainClass;
typedef struct _Block1Data Block1Data;
typedef struct _GPasteSettingsMainPrivate GPasteSettingsMainPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _GPasteSettingsWindow {
	GtkWindow parent_instance;
	GPasteSettingsWindowPrivate * priv;
};

struct _GPasteSettingsWindowClass {
	GtkWindowClass parent_class;
};

struct _GPasteSettingsWindowPrivate {
	GtkCheckButton* primary_to_history_button;
	GtkCheckButton* synchronize_clipboards_button;
	GtkCheckButton* track_changes_button;
	GtkCheckButton* shutdown_on_exit_button;
	GtkSpinButton* max_history_size_button;
	GtkSpinButton* element_size_button;
};

struct _Block1Data {
	int _ref_count_;
	GPasteSettingsWindow * self;
	GPasteSettingsMain* app;
};

struct _GPasteSettingsMain {
	GtkApplication parent_instance;
	GPasteSettingsMainPrivate * priv;
};

struct _GPasteSettingsMainClass {
	GtkApplicationClass parent_class;
};

struct _GPasteSettingsMainPrivate {
	GSettings* settings;
	GPasteSettingsWindow* window;
};


static gpointer gpaste_settings_window_parent_class = NULL;
static gpointer gpaste_settings_main_parent_class = NULL;

GType gpaste_settings_window_get_type (void) G_GNUC_CONST;
#define GPASTE_SETTINGS_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPASTE_SETTINGS_TYPE_WINDOW, GPasteSettingsWindowPrivate))
enum  {
	GPASTE_SETTINGS_WINDOW_DUMMY_PROPERTY,
	GPASTE_SETTINGS_WINDOW_PRIMARY_TO_HISTORY,
	GPASTE_SETTINGS_WINDOW_SYNCHRONIZE_CLIPBOARDS,
	GPASTE_SETTINGS_WINDOW_TRACK_CHANGES,
	GPASTE_SETTINGS_WINDOW_SHUTDOWN_ON_EXIT,
	GPASTE_SETTINGS_WINDOW_MAX_HISTORY_SIZE,
	GPASTE_SETTINGS_WINDOW_ELEMENT_SIZE
};
GPasteSettingsWindow* gpaste_settings_window_new (GtkApplication* app);
GPasteSettingsWindow* gpaste_settings_window_construct (GType object_type, GtkApplication* app);
static void gpaste_settings_window_fill (GPasteSettingsWindow* self);
GType gpaste_settings_main_get_type (void) G_GNUC_CONST;
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (Block1Data* _data1_);
gboolean gpaste_settings_main_get_primary_to_history (GPasteSettingsMain* self);
void gpaste_settings_window_set_primary_to_history (GPasteSettingsWindow* self, gboolean value);
static void _lambda1_ (Block1Data* _data1_);
gboolean gpaste_settings_window_get_primary_to_history (GPasteSettingsWindow* self);
void gpaste_settings_main_set_primary_to_history (GPasteSettingsMain* self, gboolean value);
static void __lambda1__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean gpaste_settings_main_get_synchronize_clipboards (GPasteSettingsMain* self);
void gpaste_settings_window_set_synchronize_clipboards (GPasteSettingsWindow* self, gboolean value);
static void _lambda2_ (Block1Data* _data1_);
gboolean gpaste_settings_window_get_synchronize_clipboards (GPasteSettingsWindow* self);
void gpaste_settings_main_set_synchronize_clipboards (GPasteSettingsMain* self, gboolean value);
static void __lambda2__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean gpaste_settings_main_get_track_changes (GPasteSettingsMain* self);
void gpaste_settings_window_set_track_changes (GPasteSettingsWindow* self, gboolean value);
static void _lambda3_ (Block1Data* _data1_);
gboolean gpaste_settings_window_get_track_changes (GPasteSettingsWindow* self);
void gpaste_settings_main_set_track_changes (GPasteSettingsMain* self, gboolean value);
static void __lambda3__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean gpaste_settings_main_get_shutdown_on_exit (GPasteSettingsMain* self);
void gpaste_settings_window_set_shutdown_on_exit (GPasteSettingsWindow* self, gboolean value);
static void _lambda4_ (Block1Data* _data1_);
gboolean gpaste_settings_window_get_shutdown_on_exit (GPasteSettingsWindow* self);
void gpaste_settings_main_set_shutdown_on_exit (GPasteSettingsMain* self, gboolean value);
static void __lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
guint32 gpaste_settings_main_get_max_history_size (GPasteSettingsMain* self);
void gpaste_settings_window_set_max_history_size (GPasteSettingsWindow* self, guint32 value);
static void _lambda5_ (Block1Data* _data1_);
guint32 gpaste_settings_window_get_max_history_size (GPasteSettingsWindow* self);
void gpaste_settings_main_set_max_history_size (GPasteSettingsMain* self, guint32 value);
static void __lambda5__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
guint32 gpaste_settings_main_get_element_size (GPasteSettingsMain* self);
void gpaste_settings_window_set_element_size (GPasteSettingsWindow* self, guint32 value);
static void _lambda6_ (Block1Data* _data1_);
guint32 gpaste_settings_window_get_element_size (GPasteSettingsWindow* self);
void gpaste_settings_main_set_element_size (GPasteSettingsMain* self, guint32 value);
static void __lambda6__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
static void gpaste_settings_window_finalize (GObject* obj);
static void _vala_gpaste_settings_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gpaste_settings_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define GPASTE_SETTINGS_MAIN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPASTE_SETTINGS_TYPE_MAIN, GPasteSettingsMainPrivate))
enum  {
	GPASTE_SETTINGS_MAIN_DUMMY_PROPERTY,
	GPASTE_SETTINGS_MAIN_MAX_HISTORY_SIZE,
	GPASTE_SETTINGS_MAIN_ELEMENT_SIZE,
	GPASTE_SETTINGS_MAIN_PRIMARY_TO_HISTORY,
	GPASTE_SETTINGS_MAIN_SYNCHRONIZE_CLIPBOARDS,
	GPASTE_SETTINGS_MAIN_TRACK_CHANGES,
	GPASTE_SETTINGS_MAIN_SHUTDOWN_ON_EXIT
};
GPasteSettingsMain* gpaste_settings_main_new (void);
GPasteSettingsMain* gpaste_settings_main_construct (GType object_type);
static void gpaste_settings_main_init (GPasteSettingsMain* self);
static void _gpaste_settings_main_init_g_application_activate (GApplication* _sender, gpointer self);
static void _lambda0_ (const gchar* key, GPasteSettingsMain* self);
static void __lambda0__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self);
gint gpaste_settings_main_main (gchar** args, int args_length1);
static GVariant* _variant_new1 (guint32 value);
static GVariant* _variant_new2 (guint32 value);
static void gpaste_settings_main_finalize (GObject* obj);
static void _vala_gpaste_settings_main_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gpaste_settings_main_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GPasteSettingsWindow* gpaste_settings_window_construct (GType object_type, GtkApplication* app) {
	GPasteSettingsWindow * self = NULL;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (app != NULL, NULL);
	self = (GPasteSettingsWindow*) g_object_new (object_type, "type", GTK_WINDOW_TOPLEVEL, NULL);
	_tmp0_ = _ ("GPaste Settings");
	gtk_window_set_title ((GtkWindow*) self, _tmp0_);
	gtk_window_set_application ((GtkWindow*) self, app);
	gtk_window_set_position ((GtkWindow*) self, GTK_WIN_POS_CENTER);
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
	gpaste_settings_window_fill (self);
	return self;
}


GPasteSettingsWindow* gpaste_settings_window_new (GtkApplication* app) {
	return gpaste_settings_window_construct (GPASTE_SETTINGS_TYPE_WINDOW, app);
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (Block1Data* _data1_) {
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		_g_object_unref0 (_data1_->self);
		_g_object_unref0 (_data1_->app);
		g_slice_free (Block1Data, _data1_);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _lambda1_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	gboolean _tmp0_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_primary_to_history (self);
	gpaste_settings_main_set_primary_to_history (_data1_->app, _tmp0_);
}


static void __lambda1__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	_lambda1_ (self);
}


static void _lambda2_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	gboolean _tmp0_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_synchronize_clipboards (self);
	gpaste_settings_main_set_synchronize_clipboards (_data1_->app, _tmp0_);
}


static void __lambda2__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	_lambda2_ (self);
}


static void _lambda3_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	gboolean _tmp0_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_track_changes (self);
	gpaste_settings_main_set_track_changes (_data1_->app, _tmp0_);
}


static void __lambda3__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	_lambda3_ (self);
}


static void _lambda4_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	gboolean _tmp0_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_shutdown_on_exit (self);
	gpaste_settings_main_set_shutdown_on_exit (_data1_->app, _tmp0_);
}


static void __lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	_lambda4_ (self);
}


static void _lambda5_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	guint32 _tmp0_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_max_history_size (self);
	gpaste_settings_main_set_max_history_size (_data1_->app, _tmp0_);
}


static void __lambda5__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	_lambda5_ (self);
}


static void _lambda6_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	guint32 _tmp0_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_element_size (self);
	gpaste_settings_main_set_element_size (_data1_->app, _tmp0_);
}


static void __lambda6__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	_lambda6_ (self);
}


static void gpaste_settings_window_fill (GPasteSettingsWindow* self) {
	Block1Data* _data1_;
	GtkVBox* _tmp0_ = NULL;
	GtkVBox* labels_vbox;
	const gchar* _tmp1_ = NULL;
	GtkLabel* _tmp2_ = NULL;
	GtkLabel* history_size_label;
	const gchar* _tmp3_ = NULL;
	GtkLabel* _tmp4_ = NULL;
	GtkLabel* element_size_label;
	GtkApplication* _tmp5_ = NULL;
	GtkApplication* _tmp6_;
	GPasteSettingsMain* _tmp7_;
	const gchar* _tmp8_ = NULL;
	GtkCheckButton* _tmp9_ = NULL;
	gboolean _tmp10_;
	const gchar* _tmp11_ = NULL;
	GtkCheckButton* _tmp12_ = NULL;
	gboolean _tmp13_;
	const gchar* _tmp14_ = NULL;
	GtkCheckButton* _tmp15_ = NULL;
	gboolean _tmp16_;
	const gchar* _tmp17_ = NULL;
	GtkCheckButton* _tmp18_ = NULL;
	gboolean _tmp19_;
	GtkSpinButton* _tmp20_ = NULL;
	guint32 _tmp21_;
	GtkAdjustment* _tmp22_ = NULL;
	GtkSpinButton* _tmp23_ = NULL;
	guint32 _tmp24_;
	GtkAdjustment* _tmp25_ = NULL;
	GtkVBox* _tmp26_ = NULL;
	GtkVBox* values_vbox;
	GtkHBox* _tmp27_ = NULL;
	GtkHBox* values_hbox;
	GtkVBox* _tmp28_ = NULL;
	GtkVBox* vbox;
	g_return_if_fail (self != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = (GtkVBox*) gtk_vbox_new (FALSE, 10);
	labels_vbox = g_object_ref_sink (_tmp0_);
	_tmp1_ = _ ("Max history size: ");
	_tmp2_ = (GtkLabel*) gtk_label_new (_tmp1_);
	history_size_label = g_object_ref_sink (_tmp2_);
	_tmp3_ = _ ("Max element size when displaying: ");
	_tmp4_ = (GtkLabel*) gtk_label_new (_tmp3_);
	element_size_label = g_object_ref_sink (_tmp4_);
	gtk_container_add ((GtkContainer*) labels_vbox, (GtkWidget*) history_size_label);
	gtk_container_add ((GtkContainer*) labels_vbox, (GtkWidget*) element_size_label);
	_tmp5_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp6_ = _tmp5_;
	_tmp7_ = _g_object_ref0 (GPASTE_SETTINGS_IS_MAIN (_tmp6_) ? ((GPasteSettingsMain*) _tmp6_) : NULL);
	_data1_->app = _tmp7_;
	_tmp8_ = _ ("_Primary selection affects history");
	_tmp9_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_tmp8_);
	_g_object_unref0 (self->priv->primary_to_history_button);
	self->priv->primary_to_history_button = g_object_ref_sink (_tmp9_);
	_tmp10_ = gpaste_settings_main_get_primary_to_history (_data1_->app);
	gpaste_settings_window_set_primary_to_history (self, _tmp10_);
	g_signal_connect_data ((GtkToggleButton*) self->priv->primary_to_history_button, "toggled", (GCallback) __lambda1__gtk_toggle_button_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp11_ = _ ("_Synchronize clipboard with primary selection");
	_tmp12_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_tmp11_);
	_g_object_unref0 (self->priv->synchronize_clipboards_button);
	self->priv->synchronize_clipboards_button = g_object_ref_sink (_tmp12_);
	_tmp13_ = gpaste_settings_main_get_synchronize_clipboards (_data1_->app);
	gpaste_settings_window_set_synchronize_clipboards (self, _tmp13_);
	g_signal_connect_data ((GtkToggleButton*) self->priv->synchronize_clipboards_button, "toggled", (GCallback) __lambda2__gtk_toggle_button_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp14_ = _ ("_Track clipboard changes");
	_tmp15_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_tmp14_);
	_g_object_unref0 (self->priv->track_changes_button);
	self->priv->track_changes_button = g_object_ref_sink (_tmp15_);
	_tmp16_ = gpaste_settings_main_get_track_changes (_data1_->app);
	gpaste_settings_window_set_track_changes (self, _tmp16_);
	g_signal_connect_data ((GtkToggleButton*) self->priv->track_changes_button, "toggled", (GCallback) __lambda3__gtk_toggle_button_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp17_ = _ ("Stop tracking clipboard changes when _quitting the applet");
	_tmp18_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_tmp17_);
	_g_object_unref0 (self->priv->shutdown_on_exit_button);
	self->priv->shutdown_on_exit_button = g_object_ref_sink (_tmp18_);
	_tmp19_ = gpaste_settings_main_get_shutdown_on_exit (_data1_->app);
	gpaste_settings_window_set_shutdown_on_exit (self, _tmp19_);
	g_signal_connect_data ((GtkToggleButton*) self->priv->shutdown_on_exit_button, "toggled", (GCallback) __lambda4__gtk_toggle_button_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp20_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 5, (gdouble) 255, (gdouble) 5);
	_g_object_unref0 (self->priv->max_history_size_button);
	self->priv->max_history_size_button = g_object_ref_sink (_tmp20_);
	_tmp21_ = gpaste_settings_main_get_max_history_size (_data1_->app);
	gpaste_settings_window_set_max_history_size (self, _tmp21_);
	_tmp22_ = gtk_spin_button_get_adjustment (self->priv->max_history_size_button);
	g_signal_connect_data (_tmp22_, "value-changed", (GCallback) __lambda5__gtk_adjustment_value_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp23_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 255, (gdouble) 5);
	_g_object_unref0 (self->priv->element_size_button);
	self->priv->element_size_button = g_object_ref_sink (_tmp23_);
	_tmp24_ = gpaste_settings_main_get_element_size (_data1_->app);
	gpaste_settings_window_set_element_size (self, _tmp24_);
	_tmp25_ = gtk_spin_button_get_adjustment (self->priv->element_size_button);
	g_signal_connect_data (_tmp25_, "value-changed", (GCallback) __lambda6__gtk_adjustment_value_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp26_ = (GtkVBox*) gtk_vbox_new (TRUE, 10);
	values_vbox = g_object_ref_sink (_tmp26_);
	gtk_container_add ((GtkContainer*) values_vbox, (GtkWidget*) self->priv->max_history_size_button);
	gtk_container_add ((GtkContainer*) values_vbox, (GtkWidget*) self->priv->element_size_button);
	_tmp27_ = (GtkHBox*) gtk_hbox_new (FALSE, 10);
	values_hbox = g_object_ref_sink (_tmp27_);
	gtk_container_add ((GtkContainer*) values_hbox, (GtkWidget*) labels_vbox);
	gtk_container_add ((GtkContainer*) values_hbox, (GtkWidget*) values_vbox);
	_tmp28_ = (GtkVBox*) gtk_vbox_new (FALSE, 10);
	vbox = g_object_ref_sink (_tmp28_);
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) self->priv->primary_to_history_button);
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) self->priv->synchronize_clipboards_button);
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) self->priv->track_changes_button);
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) self->priv->shutdown_on_exit_button);
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) values_hbox);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) vbox);
	_g_object_unref0 (vbox);
	_g_object_unref0 (values_hbox);
	_g_object_unref0 (values_vbox);
	_g_object_unref0 (element_size_label);
	_g_object_unref0 (history_size_label);
	_g_object_unref0 (labels_vbox);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


gboolean gpaste_settings_window_get_primary_to_history (GPasteSettingsWindow* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->primary_to_history_button);
	result = _tmp0_;
	return result;
}


void gpaste_settings_window_set_primary_to_history (GPasteSettingsWindow* self, gboolean value) {
	g_return_if_fail (self != NULL);
	gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->primary_to_history_button, value);
	g_object_notify ((GObject *) self, "primary-to-history");
}


gboolean gpaste_settings_window_get_synchronize_clipboards (GPasteSettingsWindow* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->synchronize_clipboards_button);
	result = _tmp0_;
	return result;
}


void gpaste_settings_window_set_synchronize_clipboards (GPasteSettingsWindow* self, gboolean value) {
	g_return_if_fail (self != NULL);
	gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->synchronize_clipboards_button, value);
	g_object_notify ((GObject *) self, "synchronize-clipboards");
}


gboolean gpaste_settings_window_get_track_changes (GPasteSettingsWindow* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->track_changes_button);
	result = _tmp0_;
	return result;
}


void gpaste_settings_window_set_track_changes (GPasteSettingsWindow* self, gboolean value) {
	g_return_if_fail (self != NULL);
	gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->track_changes_button, value);
	g_object_notify ((GObject *) self, "track-changes");
}


gboolean gpaste_settings_window_get_shutdown_on_exit (GPasteSettingsWindow* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->shutdown_on_exit_button);
	result = _tmp0_;
	return result;
}


void gpaste_settings_window_set_shutdown_on_exit (GPasteSettingsWindow* self, gboolean value) {
	g_return_if_fail (self != NULL);
	gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->shutdown_on_exit_button, value);
	g_object_notify ((GObject *) self, "shutdown-on-exit");
}


guint32 gpaste_settings_window_get_max_history_size (GPasteSettingsWindow* self) {
	guint32 result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = gtk_spin_button_get_value_as_int (self->priv->max_history_size_button);
	result = (guint32) _tmp0_;
	return result;
}


void gpaste_settings_window_set_max_history_size (GPasteSettingsWindow* self, guint32 value) {
	GtkAdjustment* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_spin_button_get_adjustment (self->priv->max_history_size_button);
	gtk_adjustment_set_value (_tmp0_, (gdouble) value);
	g_object_notify ((GObject *) self, "max-history-size");
}


guint32 gpaste_settings_window_get_element_size (GPasteSettingsWindow* self) {
	guint32 result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = gtk_spin_button_get_value_as_int (self->priv->element_size_button);
	result = (guint32) _tmp0_;
	return result;
}


void gpaste_settings_window_set_element_size (GPasteSettingsWindow* self, guint32 value) {
	GtkAdjustment* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_spin_button_get_adjustment (self->priv->element_size_button);
	gtk_adjustment_set_value (_tmp0_, (gdouble) value);
	g_object_notify ((GObject *) self, "element-size");
}


static void gpaste_settings_window_class_init (GPasteSettingsWindowClass * klass) {
	gpaste_settings_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GPasteSettingsWindowPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_gpaste_settings_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gpaste_settings_window_set_property;
	G_OBJECT_CLASS (klass)->finalize = gpaste_settings_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_PRIMARY_TO_HISTORY, g_param_spec_boolean ("primary-to-history", "primary-to-history", "primary-to-history", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_SYNCHRONIZE_CLIPBOARDS, g_param_spec_boolean ("synchronize-clipboards", "synchronize-clipboards", "synchronize-clipboards", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_TRACK_CHANGES, g_param_spec_boolean ("track-changes", "track-changes", "track-changes", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_SHUTDOWN_ON_EXIT, g_param_spec_boolean ("shutdown-on-exit", "shutdown-on-exit", "shutdown-on-exit", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_MAX_HISTORY_SIZE, g_param_spec_uint ("max-history-size", "max-history-size", "max-history-size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_ELEMENT_SIZE, g_param_spec_uint ("element-size", "element-size", "element-size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void gpaste_settings_window_instance_init (GPasteSettingsWindow * self) {
	self->priv = GPASTE_SETTINGS_WINDOW_GET_PRIVATE (self);
}


static void gpaste_settings_window_finalize (GObject* obj) {
	GPasteSettingsWindow * self;
	self = GPASTE_SETTINGS_WINDOW (obj);
	_g_object_unref0 (self->priv->primary_to_history_button);
	_g_object_unref0 (self->priv->synchronize_clipboards_button);
	_g_object_unref0 (self->priv->track_changes_button);
	_g_object_unref0 (self->priv->shutdown_on_exit_button);
	_g_object_unref0 (self->priv->max_history_size_button);
	_g_object_unref0 (self->priv->element_size_button);
	G_OBJECT_CLASS (gpaste_settings_window_parent_class)->finalize (obj);
}


GType gpaste_settings_window_get_type (void) {
	static volatile gsize gpaste_settings_window_type_id__volatile = 0;
	if (g_once_init_enter (&gpaste_settings_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPasteSettingsWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpaste_settings_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GPasteSettingsWindow), 0, (GInstanceInitFunc) gpaste_settings_window_instance_init, NULL };
		GType gpaste_settings_window_type_id;
		gpaste_settings_window_type_id = g_type_register_static (GTK_TYPE_WINDOW, "GPasteSettingsWindow", &g_define_type_info, 0);
		g_once_init_leave (&gpaste_settings_window_type_id__volatile, gpaste_settings_window_type_id);
	}
	return gpaste_settings_window_type_id__volatile;
}


static void _vala_gpaste_settings_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GPasteSettingsWindow * self;
	self = GPASTE_SETTINGS_WINDOW (object);
	switch (property_id) {
		case GPASTE_SETTINGS_WINDOW_PRIMARY_TO_HISTORY:
		g_value_set_boolean (value, gpaste_settings_window_get_primary_to_history (self));
		break;
		case GPASTE_SETTINGS_WINDOW_SYNCHRONIZE_CLIPBOARDS:
		g_value_set_boolean (value, gpaste_settings_window_get_synchronize_clipboards (self));
		break;
		case GPASTE_SETTINGS_WINDOW_TRACK_CHANGES:
		g_value_set_boolean (value, gpaste_settings_window_get_track_changes (self));
		break;
		case GPASTE_SETTINGS_WINDOW_SHUTDOWN_ON_EXIT:
		g_value_set_boolean (value, gpaste_settings_window_get_shutdown_on_exit (self));
		break;
		case GPASTE_SETTINGS_WINDOW_MAX_HISTORY_SIZE:
		g_value_set_uint (value, gpaste_settings_window_get_max_history_size (self));
		break;
		case GPASTE_SETTINGS_WINDOW_ELEMENT_SIZE:
		g_value_set_uint (value, gpaste_settings_window_get_element_size (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gpaste_settings_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GPasteSettingsWindow * self;
	self = GPASTE_SETTINGS_WINDOW (object);
	switch (property_id) {
		case GPASTE_SETTINGS_WINDOW_PRIMARY_TO_HISTORY:
		gpaste_settings_window_set_primary_to_history (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_WINDOW_SYNCHRONIZE_CLIPBOARDS:
		gpaste_settings_window_set_synchronize_clipboards (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_WINDOW_TRACK_CHANGES:
		gpaste_settings_window_set_track_changes (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_WINDOW_SHUTDOWN_ON_EXIT:
		gpaste_settings_window_set_shutdown_on_exit (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_WINDOW_MAX_HISTORY_SIZE:
		gpaste_settings_window_set_max_history_size (self, g_value_get_uint (value));
		break;
		case GPASTE_SETTINGS_WINDOW_ELEMENT_SIZE:
		gpaste_settings_window_set_element_size (self, g_value_get_uint (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _gpaste_settings_main_init_g_application_activate (GApplication* _sender, gpointer self) {
	gpaste_settings_main_init (self);
}


static void _lambda0_ (const gchar* key, GPasteSettingsMain* self) {
	const gchar* _tmp0_;
	GQuark _tmp1_;
	static GQuark _tmp1__label0 = 0;
	static GQuark _tmp1__label1 = 0;
	static GQuark _tmp1__label2 = 0;
	static GQuark _tmp1__label3 = 0;
	static GQuark _tmp1__label4 = 0;
	static GQuark _tmp1__label5 = 0;
	g_return_if_fail (key != NULL);
	_tmp0_ = key;
	_tmp1_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp1_ == ((0 != _tmp1__label0) ? _tmp1__label0 : (_tmp1__label0 = g_quark_from_static_string ("max-history-size")))) {
		switch (0) {
			default:
			{
				guint32 _tmp2_;
				_tmp2_ = gpaste_settings_main_get_max_history_size (self);
				gpaste_settings_window_set_max_history_size (self->priv->window, _tmp2_);
				break;
			}
		}
	} else if (_tmp1_ == ((0 != _tmp1__label1) ? _tmp1__label1 : (_tmp1__label1 = g_quark_from_static_string ("element-size")))) {
		switch (0) {
			default:
			{
				guint32 _tmp3_;
				_tmp3_ = gpaste_settings_main_get_element_size (self);
				gpaste_settings_window_set_element_size (self->priv->window, _tmp3_);
				break;
			}
		}
	} else if (_tmp1_ == ((0 != _tmp1__label2) ? _tmp1__label2 : (_tmp1__label2 = g_quark_from_static_string ("primary-to-history")))) {
		switch (0) {
			default:
			{
				gboolean _tmp4_;
				_tmp4_ = gpaste_settings_main_get_primary_to_history (self);
				gpaste_settings_window_set_primary_to_history (self->priv->window, _tmp4_);
				break;
			}
		}
	} else if (_tmp1_ == ((0 != _tmp1__label3) ? _tmp1__label3 : (_tmp1__label3 = g_quark_from_static_string ("synchronize_clipboards")))) {
		switch (0) {
			default:
			{
				gboolean _tmp5_;
				_tmp5_ = gpaste_settings_main_get_synchronize_clipboards (self);
				gpaste_settings_window_set_synchronize_clipboards (self->priv->window, _tmp5_);
				break;
			}
		}
	} else if (_tmp1_ == ((0 != _tmp1__label4) ? _tmp1__label4 : (_tmp1__label4 = g_quark_from_static_string ("track-changes")))) {
		switch (0) {
			default:
			{
				gboolean _tmp6_;
				_tmp6_ = gpaste_settings_main_get_track_changes (self);
				gpaste_settings_window_set_track_changes (self->priv->window, _tmp6_);
				break;
			}
		}
	} else if (_tmp1_ == ((0 != _tmp1__label5) ? _tmp1__label5 : (_tmp1__label5 = g_quark_from_static_string ("shutdown-on-exit")))) {
		switch (0) {
			default:
			{
				gboolean _tmp7_;
				_tmp7_ = gpaste_settings_main_get_shutdown_on_exit (self);
				gpaste_settings_window_set_shutdown_on_exit (self->priv->window, _tmp7_);
				break;
			}
		}
	}
}


static void __lambda0__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self) {
	_lambda0_ (key, self);
}


GPasteSettingsMain* gpaste_settings_main_construct (GType object_type) {
	GPasteSettingsMain * self = NULL;
	GSettings* _tmp0_ = NULL;
	self = (GPasteSettingsMain*) g_object_new (object_type, "application-id", "org.gnome.GPaste.Settings", NULL);
	g_signal_connect_object ((GApplication*) self, "activate", (GCallback) _gpaste_settings_main_init_g_application_activate, self, 0);
	_tmp0_ = g_settings_new ("org.gnome.GPaste");
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	g_signal_connect_object (self->priv->settings, "changed", (GCallback) __lambda0__g_settings_changed, self, 0);
	return self;
}


GPasteSettingsMain* gpaste_settings_main_new (void) {
	return gpaste_settings_main_construct (GPASTE_SETTINGS_TYPE_MAIN);
}


static void gpaste_settings_main_init (GPasteSettingsMain* self) {
	GPasteSettingsWindow* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gpaste_settings_window_new ((GtkApplication*) self);
	_g_object_unref0 (self->priv->window);
	self->priv->window = g_object_ref_sink (_tmp0_);
	gtk_widget_show_all ((GtkWidget*) self->priv->window);
}


gint gpaste_settings_main_main (gchar** args, int args_length1) {
	gint result = 0;
	GPasteSettingsMain* _tmp0_ = NULL;
	GPasteSettingsMain* app;
	gint _tmp2_;
	GError * _inner_error_ = NULL;
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
	gtk_init (&args_length1, &args);
	_tmp0_ = gpaste_settings_main_new ();
	app = _tmp0_;
	g_application_register ((GApplication*) app, NULL, &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch0_g_error;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError * e;
		const gchar* _tmp1_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp1_ = _ ("Fail to register the gtk application.\n");
		fprintf (stderr, "%s", _tmp1_);
		result = 1;
		_g_error_free0 (e);
		_g_object_unref0 (app);
		return result;
	}
	__finally0:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (app);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
	_tmp2_ = g_application_run ((GApplication*) app, 0, NULL);
	result = _tmp2_;
	_g_object_unref0 (app);
	return result;
}


int main (int argc, char ** argv) {
	g_type_init ();
	return gpaste_settings_main_main (argv, argc);
}


guint32 gpaste_settings_main_get_max_history_size (GPasteSettingsMain* self) {
	guint32 result;
	GVariant* _tmp0_ = NULL;
	GVariant* _tmp1_;
	guint32 _tmp2_;
	guint32 _tmp3_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = g_settings_get_value (self->priv->settings, "max-history-size");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_get_uint32 (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}


static GVariant* _variant_new1 (guint32 value) {
	return g_variant_ref_sink (g_variant_new_uint32 (value));
}


void gpaste_settings_main_set_max_history_size (GPasteSettingsMain* self, guint32 value) {
	g_return_if_fail (self != NULL);
	g_settings_set_value (self->priv->settings, "max-history-size", _variant_new1 (value));
	g_object_notify ((GObject *) self, "max-history-size");
}


guint32 gpaste_settings_main_get_element_size (GPasteSettingsMain* self) {
	guint32 result;
	GVariant* _tmp0_ = NULL;
	GVariant* _tmp1_;
	guint32 _tmp2_;
	guint32 _tmp3_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = g_settings_get_value (self->priv->settings, "element-size");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_get_uint32 (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}


static GVariant* _variant_new2 (guint32 value) {
	return g_variant_ref_sink (g_variant_new_uint32 (value));
}


void gpaste_settings_main_set_element_size (GPasteSettingsMain* self, guint32 value) {
	g_return_if_fail (self != NULL);
	g_settings_set_value (self->priv->settings, "element-size", _variant_new2 (value));
	g_object_notify ((GObject *) self, "element-size");
}


gboolean gpaste_settings_main_get_primary_to_history (GPasteSettingsMain* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_settings_get_boolean (self->priv->settings, "primary-to-history");
	result = _tmp0_;
	return result;
}


void gpaste_settings_main_set_primary_to_history (GPasteSettingsMain* self, gboolean value) {
	g_return_if_fail (self != NULL);
	g_settings_set_boolean (self->priv->settings, "primary-to-history", value);
	g_object_notify ((GObject *) self, "primary-to-history");
}


gboolean gpaste_settings_main_get_synchronize_clipboards (GPasteSettingsMain* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_settings_get_boolean (self->priv->settings, "synchronize-clipboards");
	result = _tmp0_;
	return result;
}


void gpaste_settings_main_set_synchronize_clipboards (GPasteSettingsMain* self, gboolean value) {
	g_return_if_fail (self != NULL);
	g_settings_set_boolean (self->priv->settings, "synchronize-clipboards", value);
	g_object_notify ((GObject *) self, "synchronize-clipboards");
}


gboolean gpaste_settings_main_get_track_changes (GPasteSettingsMain* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_settings_get_boolean (self->priv->settings, "track-changes");
	result = _tmp0_;
	return result;
}


void gpaste_settings_main_set_track_changes (GPasteSettingsMain* self, gboolean value) {
	g_return_if_fail (self != NULL);
	g_settings_set_boolean (self->priv->settings, "track-changes", value);
	g_object_notify ((GObject *) self, "track-changes");
}


gboolean gpaste_settings_main_get_shutdown_on_exit (GPasteSettingsMain* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_settings_get_boolean (self->priv->settings, "shutdown-on-exit");
	result = _tmp0_;
	return result;
}


void gpaste_settings_main_set_shutdown_on_exit (GPasteSettingsMain* self, gboolean value) {
	g_return_if_fail (self != NULL);
	g_settings_set_boolean (self->priv->settings, "shutdown-on-exit", value);
	g_object_notify ((GObject *) self, "shutdown-on-exit");
}


static void gpaste_settings_main_class_init (GPasteSettingsMainClass * klass) {
	gpaste_settings_main_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GPasteSettingsMainPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_gpaste_settings_main_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gpaste_settings_main_set_property;
	G_OBJECT_CLASS (klass)->finalize = gpaste_settings_main_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_MAX_HISTORY_SIZE, g_param_spec_uint ("max-history-size", "max-history-size", "max-history-size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_ELEMENT_SIZE, g_param_spec_uint ("element-size", "element-size", "element-size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_PRIMARY_TO_HISTORY, g_param_spec_boolean ("primary-to-history", "primary-to-history", "primary-to-history", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_SYNCHRONIZE_CLIPBOARDS, g_param_spec_boolean ("synchronize-clipboards", "synchronize-clipboards", "synchronize-clipboards", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_TRACK_CHANGES, g_param_spec_boolean ("track-changes", "track-changes", "track-changes", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_SHUTDOWN_ON_EXIT, g_param_spec_boolean ("shutdown-on-exit", "shutdown-on-exit", "shutdown-on-exit", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void gpaste_settings_main_instance_init (GPasteSettingsMain * self) {
	self->priv = GPASTE_SETTINGS_MAIN_GET_PRIVATE (self);
}


static void gpaste_settings_main_finalize (GObject* obj) {
	GPasteSettingsMain * self;
	self = GPASTE_SETTINGS_MAIN (obj);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->window);
	G_OBJECT_CLASS (gpaste_settings_main_parent_class)->finalize (obj);
}


GType gpaste_settings_main_get_type (void) {
	static volatile gsize gpaste_settings_main_type_id__volatile = 0;
	if (g_once_init_enter (&gpaste_settings_main_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPasteSettingsMainClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpaste_settings_main_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GPasteSettingsMain), 0, (GInstanceInitFunc) gpaste_settings_main_instance_init, NULL };
		GType gpaste_settings_main_type_id;
		gpaste_settings_main_type_id = g_type_register_static (GTK_TYPE_APPLICATION, "GPasteSettingsMain", &g_define_type_info, 0);
		g_once_init_leave (&gpaste_settings_main_type_id__volatile, gpaste_settings_main_type_id);
	}
	return gpaste_settings_main_type_id__volatile;
}


static void _vala_gpaste_settings_main_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GPasteSettingsMain * self;
	self = GPASTE_SETTINGS_MAIN (object);
	switch (property_id) {
		case GPASTE_SETTINGS_MAIN_MAX_HISTORY_SIZE:
		g_value_set_uint (value, gpaste_settings_main_get_max_history_size (self));
		break;
		case GPASTE_SETTINGS_MAIN_ELEMENT_SIZE:
		g_value_set_uint (value, gpaste_settings_main_get_element_size (self));
		break;
		case GPASTE_SETTINGS_MAIN_PRIMARY_TO_HISTORY:
		g_value_set_boolean (value, gpaste_settings_main_get_primary_to_history (self));
		break;
		case GPASTE_SETTINGS_MAIN_SYNCHRONIZE_CLIPBOARDS:
		g_value_set_boolean (value, gpaste_settings_main_get_synchronize_clipboards (self));
		break;
		case GPASTE_SETTINGS_MAIN_TRACK_CHANGES:
		g_value_set_boolean (value, gpaste_settings_main_get_track_changes (self));
		break;
		case GPASTE_SETTINGS_MAIN_SHUTDOWN_ON_EXIT:
		g_value_set_boolean (value, gpaste_settings_main_get_shutdown_on_exit (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gpaste_settings_main_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GPasteSettingsMain * self;
	self = GPASTE_SETTINGS_MAIN (object);
	switch (property_id) {
		case GPASTE_SETTINGS_MAIN_MAX_HISTORY_SIZE:
		gpaste_settings_main_set_max_history_size (self, g_value_get_uint (value));
		break;
		case GPASTE_SETTINGS_MAIN_ELEMENT_SIZE:
		gpaste_settings_main_set_element_size (self, g_value_get_uint (value));
		break;
		case GPASTE_SETTINGS_MAIN_PRIMARY_TO_HISTORY:
		gpaste_settings_main_set_primary_to_history (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_MAIN_SYNCHRONIZE_CLIPBOARDS:
		gpaste_settings_main_set_synchronize_clipboards (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_MAIN_TRACK_CHANGES:
		gpaste_settings_main_set_track_changes (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_MAIN_SHUTDOWN_ON_EXIT:
		gpaste_settings_main_set_shutdown_on_exit (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



