/* settings.c generated by valac 0.12.1, the Vala compiler
 * generated from settings.vala, do not modify */

/*
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *      Copyright 2011 Marc-Antoine Perennou <Marc-Antoine@Perennou.com>
 *
 *      This file is part of GPaste.
 *
 *      GPaste is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      GPaste is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with GPaste.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define GPASTE_DAEMON_TYPE_SETTINGS (gpaste_daemon_settings_get_type ())
#define GPASTE_DAEMON_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_DAEMON_TYPE_SETTINGS, GPasteDaemonSettings))
#define GPASTE_DAEMON_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_DAEMON_TYPE_SETTINGS, GPasteDaemonSettingsClass))
#define GPASTE_DAEMON_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_DAEMON_TYPE_SETTINGS))
#define GPASTE_DAEMON_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_DAEMON_TYPE_SETTINGS))
#define GPASTE_DAEMON_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_DAEMON_TYPE_SETTINGS, GPasteDaemonSettingsClass))

typedef struct _GPasteDaemonSettings GPasteDaemonSettings;
typedef struct _GPasteDaemonSettingsClass GPasteDaemonSettingsClass;
typedef struct _GPasteDaemonSettingsPrivate GPasteDaemonSettingsPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GPASTE_DAEMON_TYPE_DBUS_SERVER (gpaste_daemon_dbus_server_get_type ())
#define GPASTE_DAEMON_DBUS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_DAEMON_TYPE_DBUS_SERVER, GPasteDaemonDBusServer))
#define GPASTE_DAEMON_DBUS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_DAEMON_TYPE_DBUS_SERVER, GPasteDaemonDBusServerClass))
#define GPASTE_DAEMON_IS_DBUS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_DAEMON_TYPE_DBUS_SERVER))
#define GPASTE_DAEMON_IS_DBUS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_DAEMON_TYPE_DBUS_SERVER))
#define GPASTE_DAEMON_DBUS_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_DAEMON_TYPE_DBUS_SERVER, GPasteDaemonDBusServerClass))

typedef struct _GPasteDaemonDBusServer GPasteDaemonDBusServer;
typedef struct _GPasteDaemonDBusServerClass GPasteDaemonDBusServerClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _GPasteDaemonSettings {
	GObject parent_instance;
	GPasteDaemonSettingsPrivate * priv;
};

struct _GPasteDaemonSettingsClass {
	GObjectClass parent_class;
};

struct _GPasteDaemonSettingsPrivate {
	GSettings* settings;
	gboolean _primary_to_history;
	guint32 _max_history_size;
	gboolean _synchronize_clipboards;
	gboolean _track_changes;
};


static gpointer gpaste_daemon_settings_parent_class = NULL;
static GPasteDaemonSettings* gpaste_daemon_settings__instance;
static GPasteDaemonSettings* gpaste_daemon_settings__instance = NULL;

GType gpaste_daemon_settings_get_type (void) G_GNUC_CONST;
#define GPASTE_DAEMON_SETTINGS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPASTE_DAEMON_TYPE_SETTINGS, GPasteDaemonSettingsPrivate))
enum  {
	GPASTE_DAEMON_SETTINGS_DUMMY_PROPERTY,
	GPASTE_DAEMON_SETTINGS_PRIMARY_TO_HISTORY,
	GPASTE_DAEMON_SETTINGS_MAX_HISTORY_SIZE,
	GPASTE_DAEMON_SETTINGS_SYNCHRONIZE_CLIPBOARDS,
	GPASTE_DAEMON_SETTINGS_TRACK_CHANGES
};
void gpaste_daemon_settings_set_tracking_state (GPasteDaemonSettings* self, gboolean state);
static void gpaste_daemon_settings_set_track_changes (GPasteDaemonSettings* self, gboolean value);
static GPasteDaemonSettings* gpaste_daemon_settings_new (void);
static GPasteDaemonSettings* gpaste_daemon_settings_construct (GType object_type);
static gboolean gpaste_daemon_settings_get_real_primary_to_history (GPasteDaemonSettings* self);
static void gpaste_daemon_settings_set_primary_to_history (GPasteDaemonSettings* self, gboolean value);
static guint32 gpaste_daemon_settings_get_real_max_history_size (GPasteDaemonSettings* self);
static void gpaste_daemon_settings_set_max_history_size (GPasteDaemonSettings* self, guint32 value);
static gboolean gpaste_daemon_settings_get_real_track_changes (GPasteDaemonSettings* self);
static gboolean gpaste_daemon_settings_get_real_synchronize_clipboards (GPasteDaemonSettings* self);
static void gpaste_daemon_settings_set_synchronize_clipboards (GPasteDaemonSettings* self, gboolean value);
static void _lambda1_ (const gchar* key, GPasteDaemonSettings* self);
GType gpaste_daemon_dbus_server_get_type (void) G_GNUC_CONST;
guint gpaste_daemon_dbus_server_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GPasteDaemonDBusServer* gpaste_daemon_dbus_server_get_instance (void);
gboolean gpaste_daemon_settings_get_track_changes (GPasteDaemonSettings* self);
static void __lambda1__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self);
GPasteDaemonSettings* gpaste_daemon_settings_get_instance (void);
gboolean gpaste_daemon_settings_get_primary_to_history (GPasteDaemonSettings* self);
guint32 gpaste_daemon_settings_get_max_history_size (GPasteDaemonSettings* self);
gboolean gpaste_daemon_settings_get_synchronize_clipboards (GPasteDaemonSettings* self);
static void gpaste_daemon_settings_finalize (GObject* obj);
static void _vala_gpaste_daemon_settings_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gpaste_daemon_settings_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


void gpaste_daemon_settings_set_tracking_state (GPasteDaemonSettings* self, gboolean state) {
	g_return_if_fail (self != NULL);
	gpaste_daemon_settings_set_track_changes (self, state);
	g_settings_set_boolean (self->priv->settings, "track-changes", state);
}


static void _lambda1_ (const gchar* key, GPasteDaemonSettings* self) {
	const gchar* _tmp0_;
	GQuark _tmp1_;
	static GQuark _tmp1__label0 = 0;
	static GQuark _tmp1__label1 = 0;
	static GQuark _tmp1__label2 = 0;
	static GQuark _tmp1__label3 = 0;
	g_return_if_fail (key != NULL);
	_tmp0_ = key;
	_tmp1_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp1_ == ((0 != _tmp1__label0) ? _tmp1__label0 : (_tmp1__label0 = g_quark_from_static_string ("primary-to-history")))) {
		switch (0) {
			default:
			{
				gboolean _tmp2_;
				_tmp2_ = gpaste_daemon_settings_get_real_primary_to_history (self);
				gpaste_daemon_settings_set_primary_to_history (self, _tmp2_);
				break;
			}
		}
	} else if (_tmp1_ == ((0 != _tmp1__label1) ? _tmp1__label1 : (_tmp1__label1 = g_quark_from_static_string ("max-history-size")))) {
		switch (0) {
			default:
			{
				guint32 _tmp3_;
				_tmp3_ = gpaste_daemon_settings_get_real_max_history_size (self);
				gpaste_daemon_settings_set_max_history_size (self, _tmp3_);
				break;
			}
		}
	} else if (_tmp1_ == ((0 != _tmp1__label2) ? _tmp1__label2 : (_tmp1__label2 = g_quark_from_static_string ("synchronize-clipboards")))) {
		switch (0) {
			default:
			{
				gboolean _tmp4_;
				_tmp4_ = gpaste_daemon_settings_get_real_synchronize_clipboards (self);
				gpaste_daemon_settings_set_synchronize_clipboards (self, _tmp4_);
				break;
			}
		}
	} else if (_tmp1_ == ((0 != _tmp1__label3) ? _tmp1__label3 : (_tmp1__label3 = g_quark_from_static_string ("track-changes")))) {
		switch (0) {
			default:
			{
				gboolean _tmp5_;
				GPasteDaemonDBusServer* _tmp6_ = NULL;
				_tmp5_ = gpaste_daemon_settings_get_real_track_changes (self);
				gpaste_daemon_settings_set_track_changes (self, _tmp5_);
				_tmp6_ = gpaste_daemon_dbus_server_get_instance ();
				g_signal_emit_by_name (_tmp6_, "tracking", self->priv->_track_changes);
				break;
			}
		}
	}
}


static void __lambda1__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self) {
	_lambda1_ (key, self);
}


static GPasteDaemonSettings* gpaste_daemon_settings_construct (GType object_type) {
	GPasteDaemonSettings * self = NULL;
	GSettings* _tmp0_ = NULL;
	gboolean _tmp1_;
	guint32 _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	self = (GPasteDaemonSettings*) g_object_new (object_type, NULL);
	_tmp0_ = g_settings_new ("org.gnome.GPaste");
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = gpaste_daemon_settings_get_real_primary_to_history (self);
	gpaste_daemon_settings_set_primary_to_history (self, _tmp1_);
	_tmp2_ = gpaste_daemon_settings_get_real_max_history_size (self);
	gpaste_daemon_settings_set_max_history_size (self, _tmp2_);
	_tmp3_ = gpaste_daemon_settings_get_real_track_changes (self);
	gpaste_daemon_settings_set_track_changes (self, _tmp3_);
	_tmp4_ = gpaste_daemon_settings_get_real_synchronize_clipboards (self);
	gpaste_daemon_settings_set_synchronize_clipboards (self, _tmp4_);
	g_signal_connect_object (self->priv->settings, "changed", (GCallback) __lambda1__g_settings_changed, self, 0);
	return self;
}


static GPasteDaemonSettings* gpaste_daemon_settings_new (void) {
	return gpaste_daemon_settings_construct (GPASTE_DAEMON_TYPE_SETTINGS);
}


GPasteDaemonSettings* gpaste_daemon_settings_get_instance (void) {
	GPasteDaemonSettings* result;
	if (gpaste_daemon_settings__instance == NULL) {
		GPasteDaemonSettings* _tmp0_ = NULL;
		_tmp0_ = gpaste_daemon_settings_new ();
		_g_object_unref0 (gpaste_daemon_settings__instance);
		gpaste_daemon_settings__instance = _tmp0_;
	}
	result = gpaste_daemon_settings__instance;
	return result;
}


static gboolean gpaste_daemon_settings_get_real_primary_to_history (GPasteDaemonSettings* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_settings_get_boolean (self->priv->settings, "primary-to-history");
	result = _tmp0_;
	return result;
}


static guint32 gpaste_daemon_settings_get_real_max_history_size (GPasteDaemonSettings* self) {
	guint32 result;
	GVariant* _tmp0_ = NULL;
	GVariant* _tmp1_;
	guint32 _tmp2_;
	guint32 _tmp3_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = g_settings_get_value (self->priv->settings, "max-history-size");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_get_uint32 (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_unref0 (_tmp1_);
	result = _tmp3_;
	return result;
}


static gboolean gpaste_daemon_settings_get_real_synchronize_clipboards (GPasteDaemonSettings* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_settings_get_boolean (self->priv->settings, "synchronize-clipboards");
	result = _tmp0_;
	return result;
}


static gboolean gpaste_daemon_settings_get_real_track_changes (GPasteDaemonSettings* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_settings_get_boolean (self->priv->settings, "track-changes");
	result = _tmp0_;
	return result;
}


gboolean gpaste_daemon_settings_get_primary_to_history (GPasteDaemonSettings* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_primary_to_history;
	return result;
}


static void gpaste_daemon_settings_set_primary_to_history (GPasteDaemonSettings* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_primary_to_history = value;
	g_object_notify ((GObject *) self, "primary-to-history");
}


guint32 gpaste_daemon_settings_get_max_history_size (GPasteDaemonSettings* self) {
	guint32 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_max_history_size;
	return result;
}


static void gpaste_daemon_settings_set_max_history_size (GPasteDaemonSettings* self, guint32 value) {
	g_return_if_fail (self != NULL);
	self->priv->_max_history_size = value;
	g_object_notify ((GObject *) self, "max-history-size");
}


gboolean gpaste_daemon_settings_get_synchronize_clipboards (GPasteDaemonSettings* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_synchronize_clipboards;
	return result;
}


static void gpaste_daemon_settings_set_synchronize_clipboards (GPasteDaemonSettings* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_synchronize_clipboards = value;
	g_object_notify ((GObject *) self, "synchronize-clipboards");
}


gboolean gpaste_daemon_settings_get_track_changes (GPasteDaemonSettings* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_track_changes;
	return result;
}


static void gpaste_daemon_settings_set_track_changes (GPasteDaemonSettings* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_track_changes = value;
	g_object_notify ((GObject *) self, "track-changes");
}


static void gpaste_daemon_settings_class_init (GPasteDaemonSettingsClass * klass) {
	gpaste_daemon_settings_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GPasteDaemonSettingsPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_gpaste_daemon_settings_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gpaste_daemon_settings_set_property;
	G_OBJECT_CLASS (klass)->finalize = gpaste_daemon_settings_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_DAEMON_SETTINGS_PRIMARY_TO_HISTORY, g_param_spec_boolean ("primary-to-history", "primary-to-history", "primary-to-history", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_DAEMON_SETTINGS_MAX_HISTORY_SIZE, g_param_spec_uint ("max-history-size", "max-history-size", "max-history-size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_DAEMON_SETTINGS_SYNCHRONIZE_CLIPBOARDS, g_param_spec_boolean ("synchronize-clipboards", "synchronize-clipboards", "synchronize-clipboards", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_DAEMON_SETTINGS_TRACK_CHANGES, g_param_spec_boolean ("track-changes", "track-changes", "track-changes", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void gpaste_daemon_settings_instance_init (GPasteDaemonSettings * self) {
	self->priv = GPASTE_DAEMON_SETTINGS_GET_PRIVATE (self);
}


static void gpaste_daemon_settings_finalize (GObject* obj) {
	GPasteDaemonSettings * self;
	self = GPASTE_DAEMON_SETTINGS (obj);
	_g_object_unref0 (self->priv->settings);
	G_OBJECT_CLASS (gpaste_daemon_settings_parent_class)->finalize (obj);
}


GType gpaste_daemon_settings_get_type (void) {
	static volatile gsize gpaste_daemon_settings_type_id__volatile = 0;
	if (g_once_init_enter (&gpaste_daemon_settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPasteDaemonSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpaste_daemon_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GPasteDaemonSettings), 0, (GInstanceInitFunc) gpaste_daemon_settings_instance_init, NULL };
		GType gpaste_daemon_settings_type_id;
		gpaste_daemon_settings_type_id = g_type_register_static (G_TYPE_OBJECT, "GPasteDaemonSettings", &g_define_type_info, 0);
		g_once_init_leave (&gpaste_daemon_settings_type_id__volatile, gpaste_daemon_settings_type_id);
	}
	return gpaste_daemon_settings_type_id__volatile;
}


static void _vala_gpaste_daemon_settings_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GPasteDaemonSettings * self;
	self = GPASTE_DAEMON_SETTINGS (object);
	switch (property_id) {
		case GPASTE_DAEMON_SETTINGS_PRIMARY_TO_HISTORY:
		g_value_set_boolean (value, gpaste_daemon_settings_get_primary_to_history (self));
		break;
		case GPASTE_DAEMON_SETTINGS_MAX_HISTORY_SIZE:
		g_value_set_uint (value, gpaste_daemon_settings_get_max_history_size (self));
		break;
		case GPASTE_DAEMON_SETTINGS_SYNCHRONIZE_CLIPBOARDS:
		g_value_set_boolean (value, gpaste_daemon_settings_get_synchronize_clipboards (self));
		break;
		case GPASTE_DAEMON_SETTINGS_TRACK_CHANGES:
		g_value_set_boolean (value, gpaste_daemon_settings_get_track_changes (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gpaste_daemon_settings_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GPasteDaemonSettings * self;
	self = GPASTE_DAEMON_SETTINGS (object);
	switch (property_id) {
		case GPASTE_DAEMON_SETTINGS_PRIMARY_TO_HISTORY:
		gpaste_daemon_settings_set_primary_to_history (self, g_value_get_boolean (value));
		break;
		case GPASTE_DAEMON_SETTINGS_MAX_HISTORY_SIZE:
		gpaste_daemon_settings_set_max_history_size (self, g_value_get_uint (value));
		break;
		case GPASTE_DAEMON_SETTINGS_SYNCHRONIZE_CLIPBOARDS:
		gpaste_daemon_settings_set_synchronize_clipboards (self, g_value_get_boolean (value));
		break;
		case GPASTE_DAEMON_SETTINGS_TRACK_CHANGES:
		gpaste_daemon_settings_set_track_changes (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



